Index: drivers/filesystems/btrfs/create.c
===================================================================
--- drivers/filesystems/btrfs/create.c	(révision 74430)
+++ drivers/filesystems/btrfs/create.c	(copie de travail)
@@ -1526,43 +1350,14 @@
             if (dc->type == BTRFS_TYPE_DIRECTORY)
                 fcb->fileref = sf2;
             
-            sf2->index = dc->index;
             sf2->dc = dc;
             dc->fileref = sf2;
             
-            sf2->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, dc->utf8.Length, ALLOC_TAG);
-            if (!sf2->utf8.Buffer) {
-                ERR("out of memory\n");
-                free_fileref(sf2);
-                return STATUS_INSUFFICIENT_RESOURCES;
-            }
-            
-            sf2->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, dc->name.Length, ALLOC_TAG);
-            if (!sf2->filepart.Buffer) {
-                ERR("out of memory\n");
-                free_fileref(sf2);
-                return STATUS_INSUFFICIENT_RESOURCES;
-            }
-            
-            sf2->filepart_uc.Buffer = ExAllocatePoolWithTag(PagedPool, dc->name_uc.Length, ALLOC_TAG);
-            if (!sf2->filepart_uc.Buffer) {
-                ERR("out of memory\n");
-                free_fileref(sf2);
-                return STATUS_INSUFFICIENT_RESOURCES;
-            }
-            
-            sf2->utf8.Length = sf2->utf8.MaximumLength = dc->utf8.Length;
-            RtlCopyMemory(sf2->utf8.Buffer, dc->utf8.Buffer, dc->utf8.Length);
-            
-            sf2->filepart.Length = sf2->filepart.MaximumLength = dc->name.Length;
-            RtlCopyMemory(sf2->filepart.Buffer, dc->name.Buffer, dc->name.Length);
-            
-            sf2->filepart_uc.Length = sf2->filepart_uc.MaximumLength = dc->name_uc.Length;
-            RtlCopyMemory(sf2->filepart_uc.Buffer, dc->name_uc.Buffer, dc->name_uc.Length);
-            
             sf2->parent = (struct _file_ref*)sf;
             
-            insert_fileref_child(sf, sf2, TRUE);
+            ExAcquireResourceExclusiveLite(&sf->nonpaged->children_lock, TRUE);
+            InsertTailList(&sf->children, &sf2->list_entry);
+            ExReleaseResourceLite(&sf->nonpaged->children_lock);
             
             increase_fileref_refcount(sf);
         }
@@ -1577,10 +1372,10 @@
                       POOL_TYPE pooltype, BOOL case_sensitive, PIRP Irp) {
     UNICODE_STRING fnus2;
     file_ref *dir, *sf, *sf2;
-    ULONG i, num_parts;
-    UNICODE_STRING* parts = NULL;
+    LIST_ENTRY parts;
     BOOL has_stream;
     NTSTATUS Status;
+    LIST_ENTRY* le;
     
     TRACE("(%p, %p, %p, %u, %p)\n", Vcb, pfr, related, parent, parsed);
 
@@ -1617,15 +1412,8 @@
         }
         
         if (fnus2.Length == sizeof(WCHAR)) {
-            if (Vcb->root_fileref->open_count == 0) { // don't allow root to be opened on unmounted FS
-                ULONG cc;
-                IO_STATUS_BLOCK iosb;
-                
-                Status = dev_ioctl(first_device(Vcb)->devobj, IOCTL_STORAGE_CHECK_VERIFY, NULL, 0, &cc, sizeof(ULONG), TRUE, &iosb);
-                
-                if (!NT_SUCCESS(Status))
-                    return Status;
-            }
+            if (Vcb->root_fileref->open_count == 0 && !(Vcb->Vpb->Flags & VPB_MOUNTED)) // don't allow root to be opened on unmounted FS
+                return STATUS_DEVICE_NOT_READY;
             
             increase_fileref_refcount(Vcb->root_fileref);
             *pfr = Vcb->root_fileref;
@@ -1649,13 +1437,11 @@
         return STATUS_OBJECT_PATH_NOT_FOUND;
     }
     
-    if (fnus->Length == 0) {
-        num_parts = 0;
-    } else if (fnus->Length == wcslen(datastring) * sizeof(WCHAR) &&
-               RtlCompareMemory(fnus->Buffer, datastring, wcslen(datastring) * sizeof(WCHAR)) == wcslen(datastring) * sizeof(WCHAR)) {
-        num_parts = 0;
-    } else {
-        Status = split_path(&fnus2, &parts, &num_parts, &has_stream);
+    InitializeListHead(&parts);
+    
+    if (fnus->Length != 0 &&
+        (fnus->Length != wcslen(datastring) * sizeof(WCHAR) || RtlCompareMemory(fnus->Buffer, datastring, wcslen(datastring) * sizeof(WCHAR)) != wcslen(datastring) * sizeof(WCHAR))) {
+        Status = split_path(Vcb, &fnus2, &parts, &has_stream);
         if (!NT_SUCCESS(Status)) {
             ERR("split_path returned %08x\n", Status);
             return Status;
@@ -1665,16 +1451,21 @@
     sf = dir;
     increase_fileref_refcount(dir);
     
-    if (parent) {
-        num_parts--;
+    if (parent && !IsListEmpty(&parts)) {
+        name_bit* nb;
         
-        if (has_stream && num_parts > 0) {
-            num_parts--;
+        nb = CONTAINING_RECORD(RemoveTailList(&parts), name_bit, list_entry);
+        ExFreePool(nb);
+        
+        if (has_stream && !IsListEmpty(&parts)) {
+            nb = CONTAINING_RECORD(RemoveTailList(&parts), name_bit, list_entry);
+            ExFreePool(nb);
+            
             has_stream = FALSE;
         }
     }
     
-    if (num_parts == 0) {
+    if (IsListEmpty(&parts)) {
         Status = STATUS_SUCCESS;
         *pfr = dir;
         
@@ -1684,10 +1475,13 @@
         goto end2;
     }
     
-    for (i = 0; i < num_parts; i++) {
-        BOOL lastpart = (i == num_parts-1) || (i == num_parts-2 && has_stream);
+    le = parts.Flink;
+    while (le != &parts) {
+        name_bit* nb = CONTAINING_RECORD(le, name_bit, list_entry);
+        BOOL lastpart = le->Flink == &parts || (has_stream && le->Flink->Flink == &parts);
+        BOOL streampart = has_stream && le->Flink == &parts;
         
-        Status = open_fileref_child(Vcb, sf, &parts[i], case_sensitive, lastpart, has_stream && i == num_parts - 1, pooltype, &sf2, Irp);
+        Status = open_fileref_child(Vcb, sf, &nb->us, case_sensitive, lastpart, streampart, pooltype, &sf2, Irp);
         if (!NT_SUCCESS(Status)) {
             if (Status == STATUS_OBJECT_PATH_NOT_FOUND || Status == STATUS_OBJECT_NAME_NOT_FOUND)
                 TRACE("open_fileref_child returned %08x\n", Status);
@@ -1697,9 +1491,13 @@
             goto end;
         }
         
-        if (i == num_parts - 1) {
-            if (fn_offset)
-                *fn_offset = parts[has_stream ? (num_parts - 2) : (num_parts - 1)].Buffer - fnus->Buffer;
+        if (le->Flink == &parts) { // last entry
+            if (fn_offset) {
+                if (has_stream)
+                    nb = CONTAINING_RECORD(le->Blink, name_bit, list_entry);
+                
+                *fn_offset = nb->us.Buffer - fnus->Buffer;
+            }
             
             break;
         }
@@ -1707,14 +1505,19 @@
         if (sf2->fcb->atts & FILE_ATTRIBUTE_REPARSE_POINT) {
             Status = STATUS_REPARSE;
             
-            if (parsed)
-                *parsed = (parts[i+1].Buffer - fnus->Buffer - 1) * sizeof(WCHAR);
+            if (parsed) {
+                name_bit* nb2 = CONTAINING_RECORD(le->Flink, name_bit, list_entry);
+                
+                *parsed = (nb2->us.Buffer - fnus->Buffer - 1) * sizeof(WCHAR);
+            }
             
             break;
         }
         
-        free_fileref(sf);
+        free_fileref(Vcb, sf);
         sf = sf2;
+        
+        le = le->Flink;
     }
     
     if (Status != STATUS_REPARSE)
@@ -1722,63 +1525,21 @@
     *pfr = sf2;
     
 end:
-    free_fileref(sf);
+    free_fileref(Vcb, sf);
     
+    while (!IsListEmpty(&parts)) {
+        name_bit* nb = CONTAINING_RECORD(RemoveHeadList(&parts), name_bit, list_entry);
+        ExFreeToPagedLookasideList(&Vcb->name_bit_lookaside, nb);
+    }
+    
 end2:
-    if (parts)
-        ExFreePool(parts);
-    
     TRACE("returning %08x\n", Status);
     
     return Status;
 }
 
-NTSTATUS fcb_get_last_dir_index(fcb* fcb, UINT64* index, PIRP Irp) {
-    KEY searchkey;
-    traverse_ptr tp, prev_tp;
+NTSTATUS add_dir_child(fcb* fcb, UINT64 inode, BOOL subvol, PANSI_STRING utf8, PUNICODE_STRING name, UINT8 type, dir_child** pdc) {
     NTSTATUS Status;
-    
-    ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
-    if (fcb->last_dir_index != 0) {
-        *index = fcb->last_dir_index;
-        fcb->last_dir_index++;
-        Status = STATUS_SUCCESS;
-        goto end;
-    }
-    
-    searchkey.obj_id = fcb->inode;
-    searchkey.obj_type = TYPE_DIR_INDEX + 1;
-    searchkey.offset = 0;
-    
-    Status = find_item(fcb->Vcb, fcb->subvol, &tp, &searchkey, FALSE, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("error - find_item returned %08x\n", Status);
-        goto end;
-    }
-    
-    if (tp.item->key.obj_id > searchkey.obj_id || (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type >= searchkey.obj_type)) {
-        if (find_prev_item(fcb->Vcb, &tp, &prev_tp, FALSE, Irp))
-            tp = prev_tp;
-    }
-    
-    if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == TYPE_DIR_INDEX) {
-        fcb->last_dir_index = tp.item->key.offset + 1;
-    } else
-        fcb->last_dir_index = 2;
-    
-    *index = fcb->last_dir_index;
-    fcb->last_dir_index++;
-    
-    Status = STATUS_SUCCESS;
-    
-end:
-    ExReleaseResourceLite(fcb->Header.Resource);
-    
-    return Status;
-}
-
-NTSTATUS add_dir_child(fcb* fcb, UINT64 inode, BOOL subvol, UINT64 index, PANSI_STRING utf8, PUNICODE_STRING name, PUNICODE_STRING name_uc, UINT8 type, dir_child** pdc) {
     dir_child* dc;
     
     dc = ExAllocatePoolWithTag(PagedPool, sizeof(dir_child), ALLOC_TAG);
@@ -1802,19 +1563,9 @@
         return STATUS_INSUFFICIENT_RESOURCES;
     }
     
-    dc->name_uc.Buffer = ExAllocatePoolWithTag(PagedPool, name_uc->Length, ALLOC_TAG);
-    if (!dc->name_uc.Buffer) {
-        ERR("out of memory\n");
-        ExFreePool(dc->utf8.Buffer);
-        ExFreePool(dc->name.Buffer);
-        ExFreePool(dc);
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
     dc->key.obj_id = inode;
     dc->key.obj_type = subvol ? TYPE_ROOT_ITEM : TYPE_INODE_ITEM;
     dc->key.offset = 0;
-    dc->index = index;
     dc->type = type;
     dc->fileref = NULL;
     
@@ -1823,15 +1574,29 @@
     
     dc->name.Length = dc->name.MaximumLength = name->Length;
     RtlCopyMemory(dc->name.Buffer, name->Buffer, name->Length);
+        
+    Status = RtlUpcaseUnicodeString(&dc->name_uc, name, TRUE);
+    if (!NT_SUCCESS(Status)) {
+        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
+        ExFreePool(dc->utf8.Buffer);
+        ExFreePool(dc->name.Buffer);
+        ExFreePool(dc);
+        return Status;
+    }
     
-    dc->name_uc.Length = dc->name_uc.MaximumLength = name_uc->Length;
-    RtlCopyMemory(dc->name_uc.Buffer, name_uc->Buffer, name_uc->Length);
-    
     dc->hash = calc_crc32c(0xffffffff, (UINT8*)dc->name.Buffer, dc->name.Length);
     dc->hash_uc = calc_crc32c(0xffffffff, (UINT8*)dc->name_uc.Buffer, dc->name_uc.Length);
     
     ExAcquireResourceExclusiveLite(&fcb->nonpaged->dir_children_lock, TRUE);
     
+    if (IsListEmpty(&fcb->dir_children_index))
+        dc->index = 2;
+    else {
+        dir_child* dc2 = CONTAINING_RECORD(fcb->dir_children_index.Blink, dir_child, list_entry_index);
+        
+        dc->index = max(2, dc2->index + 1);
+    }
+    
     InsertTailList(&fcb->dir_children_index, &dc->list_entry_index);
     
     insert_dir_child_into_hash_lists(fcb, dc);
@@ -1849,7 +1614,7 @@
     fcb* fcb;
     ULONG utf8len;
     char* utf8 = NULL;
-    UINT64 dirpos, inode;
+    UINT64 inode;
     UINT8 type;
     LARGE_INTEGER time;
     BTRFS_TIME now;
@@ -1858,6 +1623,7 @@
     ULONG defda;
     file_ref* fileref;
     dir_child* dc;
+    ANSI_STRING utf8as;
 #ifdef DEBUG_FCB_REFCOUNTS
     LONG rc;
 #endif
@@ -1880,13 +1646,6 @@
     
     utf8[utf8len] = 0;
     
-    Status = fcb_get_last_dir_index(parfileref->fcb, &dirpos, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("fcb_get_last_dir_index returned %08x\n", Status);
-        ExFreePool(utf8);
-        return Status;
-    }
-    
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
     
@@ -1929,7 +1688,7 @@
     if (IrpSp->Parameters.Create.FileAttributes == FILE_ATTRIBUTE_NORMAL)
         IrpSp->Parameters.Create.FileAttributes = defda;
     
-    fcb = create_fcb(pool_type);
+    fcb = create_fcb(Vcb, pool_type);
     if (!fcb) {
         ERR("out of memory\n");
         ExFreePool(utf8);
@@ -1982,6 +1741,9 @@
             fcb->inode_item.flags |= BTRFS_INODE_COMPRESS;
     }
     
+    fcb->prop_compression = parfileref->fcb->prop_compression;
+    fcb->prop_compression_changed = fcb->prop_compression != PropCompression_None;
+    
     fcb->inode_item_changed = TRUE;
     
     fcb->Header.IsFastIoPossible = fast_io_possible(fcb);
@@ -2048,7 +1810,7 @@
         fcb->ea_changed = TRUE;
     }
     
-    fileref = create_fileref();
+    fileref = create_fileref(Vcb);
     if (!fileref) {
         ERR("out of memory\n");
         free_fcb(fcb);
@@ -2056,40 +1818,13 @@
     }
     
     fileref->fcb = fcb;
-    fileref->index = dirpos;
-
-    fileref->utf8.MaximumLength = fileref->utf8.Length = utf8len;
-    fileref->utf8.Buffer = utf8;
     
-    fileref->filepart.Length = fileref->filepart.MaximumLength = fpus->Length;
-    
-    if (fileref->filepart.Length == 0)
-        fileref->filepart.Buffer = NULL;
-    else {
-        fileref->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->filepart.Length, ALLOC_TAG);
-        
-        if (!fileref->filepart.Buffer) {
-            ERR("out of memory\n");
-            free_fcb(fcb);
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-        
-        RtlCopyMemory(fileref->filepart.Buffer, fpus->Buffer, fpus->Length);
-    }
-    
-    Status = RtlUpcaseUnicodeString(&fileref->filepart_uc, &fileref->filepart, TRUE);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        free_fileref(fileref);
-        return Status;
-    }
-
     if (Irp->Overlay.AllocationSize.QuadPart > 0 && !write_fcb_compressed(fcb)) {
         Status = extend_file(fcb, fileref, Irp->Overlay.AllocationSize.QuadPart, TRUE, NULL, rollback);
         
         if (!NT_SUCCESS(Status)) {
             ERR("extend_file returned %08x\n", Status);
-            free_fileref(fileref);
+            free_fileref(Vcb, fileref);
             return Status;
         }
     }
@@ -2105,15 +1840,22 @@
     
     fileref->parent = parfileref;
 
-    insert_fileref_child(parfileref, fileref, TRUE);
+    utf8as.Buffer = utf8;
+    utf8as.Length = utf8as.MaximumLength = utf8len;
     
-    Status = add_dir_child(fileref->parent->fcb, fcb->inode, FALSE, fileref->index, &fileref->utf8, &fileref->filepart, &fileref->filepart_uc, fcb->type, &dc);
+    Status = add_dir_child(fileref->parent->fcb, fcb->inode, FALSE, &utf8as, fpus, fcb->type, &dc);
     if (!NT_SUCCESS(Status))
         WARN("add_dir_child returned %08x\n", Status);
     
+    ExFreePool(utf8);
+    
     fileref->dc = dc;
     dc->fileref = fileref;
     
+    ExAcquireResourceExclusiveLite(&parfileref->nonpaged->children_lock, TRUE);
+    InsertTailList(&parfileref->children, &fileref->list_entry);
+    ExReleaseResourceLite(&parfileref->nonpaged->children_lock);
+    
     increase_fileref_refcount(parfileref);
     
     if (fcb->type == BTRFS_TYPE_DIRECTORY) {
@@ -2120,7 +1862,7 @@
         fcb->hash_ptrs = ExAllocatePoolWithTag(PagedPool, sizeof(LIST_ENTRY*) * 256, ALLOC_TAG);
         if (!fcb->hash_ptrs) {
             ERR("out of memory\n");
-            free_fileref(fileref);
+            free_fileref(Vcb, fileref);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
         
@@ -2129,7 +1871,7 @@
         fcb->hash_ptrs_uc = ExAllocatePoolWithTag(PagedPool, sizeof(LIST_ENTRY*) * 256, ALLOC_TAG);
         if (!fcb->hash_ptrs_uc) {
             ERR("out of memory\n");
-            free_fileref(fileref);
+            free_fileref(Vcb, fileref);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
         
@@ -2163,6 +1905,7 @@
     NTSTATUS Status;
     KEY searchkey;
     traverse_ptr tp;
+    dir_child* dc;
 #ifdef DEBUG_FCB_REFCOUNTS
     LONG rc;
 #endif
@@ -2205,7 +1948,7 @@
         return Status;
     }
     
-    free_fileref(parfileref);
+    free_fileref(Vcb, parfileref);
     
     parfileref = newpar;
     *pparfileref = parfileref;
@@ -2225,7 +1968,7 @@
         return STATUS_OBJECT_NAME_INVALID;
     }
         
-    fcb = create_fcb(pool_type);
+    fcb = create_fcb(Vcb, pool_type);
     if (!fcb) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
@@ -2307,7 +2050,7 @@
     } else
         fcb->adsmaxlen -= overhead + utf8len + xapreflen;
     
-    fileref = create_fileref();
+    fileref = create_fileref(Vcb);
     if (!fileref) {
         ERR("out of memory\n");
         free_fcb(fcb);
@@ -2315,24 +2058,54 @@
     }
     
     fileref->fcb = fcb;
-
-    fileref->filepart.MaximumLength = fileref->filepart.Length = stream->Length;
-    fileref->filepart.Buffer = ExAllocatePoolWithTag(pool_type, fileref->filepart.MaximumLength, ALLOC_TAG);
-    if (!fileref->filepart.Buffer) {
+    
+    dc = ExAllocatePoolWithTag(PagedPool, sizeof(dir_child), ALLOC_TAG);
+    if (!dc) {
         ERR("out of memory\n");
-        free_fileref(fileref);
+        free_fileref(Vcb, fileref);
         return STATUS_INSUFFICIENT_RESOURCES;
     }
     
-    RtlCopyMemory(fileref->filepart.Buffer, stream->Buffer, stream->Length);
+    RtlZeroMemory(dc, sizeof(dir_child));
     
-    Status = RtlUpcaseUnicodeString(&fileref->filepart_uc, &fileref->filepart, TRUE);
+    dc->utf8.MaximumLength = dc->utf8.Length = fcb->adsxattr.Length - xapreflen;
+    dc->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, dc->utf8.MaximumLength, ALLOC_TAG);
+    if (!dc->utf8.Buffer) {
+        ERR("out of memory\n");
+        ExFreePool(dc);
+        free_fileref(Vcb, fileref);
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+    
+    RtlCopyMemory(dc->utf8.Buffer, &fcb->adsxattr.Buffer[xapreflen], fcb->adsxattr.Length - xapreflen);
+    
+    dc->name.MaximumLength = dc->name.Length = stream->Length;
+    dc->name.Buffer = ExAllocatePoolWithTag(pool_type, dc->name.MaximumLength, ALLOC_TAG);
+    if (!dc->name.Buffer) {
+        ERR("out of memory\n");
+        ExFreePool(dc->utf8.Buffer);
+        ExFreePool(dc);
+        free_fileref(Vcb, fileref);
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+    
+    RtlCopyMemory(dc->name.Buffer, stream->Buffer, stream->Length);
+    
+    Status = RtlUpcaseUnicodeString(&dc->name_uc, &dc->name, TRUE);
     if (!NT_SUCCESS(Status)) {
         ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        free_fileref(fileref);
+        ExFreePool(dc->utf8.Buffer);
+        ExFreePool(dc->name.Buffer);
+        ExFreePool(dc);
+        free_fileref(Vcb, fileref);
         return Status;
     }
     
+    dc->fileref = fileref;
+    fileref->dc = dc;
+    
+    InsertHeadList(&parfileref->fcb->dir_children_index, &dc->list_entry_index);
+    
     mark_fcb_dirty(fcb);
     mark_fileref_dirty(fileref);
     
@@ -2354,7 +2127,9 @@
     
     fileref->parent = (struct _file_ref*)parfileref;
     
-    insert_fileref_child(parfileref, fileref, TRUE);
+    ExAcquireResourceExclusiveLite(&parfileref->nonpaged->children_lock, TRUE);
+    InsertTailList(&parfileref->children, &fileref->list_entry);
+    ExReleaseResourceLite(&parfileref->nonpaged->children_lock);
     
     increase_fileref_refcount(parfileref);
     
@@ -2368,7 +2143,7 @@
     NTSTATUS Status;
 //     fcb *fcb, *parfcb = NULL;
     file_ref *fileref, *parfileref = NULL;
-    ULONG i, j, fn_offset;
+    ULONG i, j;
 //     ULONG utf8len;
     ccb* ccb;
     static WCHAR datasuf[] = {':','$','D','A','T','A',0};
@@ -2427,8 +2202,6 @@
     RtlCopyMemory(fpus.Buffer, &fnus->Buffer[i], (j - i + 1) * sizeof(WCHAR));
     fpus.Buffer[j - i + 1] = 0;
     
-    fn_offset = i;
-    
     if (fpus.Length > dsus.Length) { // check for :$DATA suffix
         UNICODE_STRING lb;
                 
@@ -2501,7 +2274,7 @@
     if (!ccb) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
-        free_fileref(fileref);
+        free_fileref(Vcb, fileref);
         goto end;
     }
     
@@ -2529,11 +2302,6 @@
     InterlockedIncrement(&Vcb->open_files);
     
     FileObject->FsContext2 = ccb;
-    
-    if (fn_offset > 0) {
-        FileObject->FileName.Length -= fn_offset * sizeof(WCHAR);
-        RtlMoveMemory(&FileObject->FileName.Buffer[0], &FileObject->FileName.Buffer[fn_offset], FileObject->FileName.Length);
-    }
 
     FileObject->SectionObjectPointer = &fileref->fcb->nonpaged->segment_object;
     
@@ -2571,7 +2339,7 @@
     
 end2:
     if (parfileref && !loaded_related)
-        free_fileref(parfileref);
+        free_fileref(Vcb, parfileref);
     
     return Status;
 }
@@ -2721,7 +2489,7 @@
             return STATUS_INSUFFICIENT_RESOURCES;
         }
         
-        Status = read_file(fcb, *data, 0, size, &bytes_read, NULL, TRUE);
+        Status = read_file(fcb, *data, 0, size, &bytes_read, NULL);
         if (!NT_SUCCESS(Status)) {
             ERR("read_file_fcb returned %08x\n", Status);
             ExFreePool(*data);
@@ -2819,6 +2587,47 @@
     return STATUS_SUCCESS;
 }
 
+static void fcb_load_csums(fcb* fcb, PIRP Irp) {
+    LIST_ENTRY* le;
+    NTSTATUS Status;
+    
+    if (fcb->csum_loaded)
+        return;
+    
+    if (IsListEmpty(&fcb->extents) || fcb->inode_item.flags & BTRFS_INODE_NODATASUM)
+        goto end;
+    
+    le = fcb->extents.Flink;
+    while (le != &fcb->extents) {
+        extent* ext = CONTAINING_RECORD(le, extent, list_entry);
+        
+        if (ext->extent_data.type == EXTENT_TYPE_REGULAR) {
+            EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ext->extent_data.data[0];
+            UINT64 len;
+            
+            len = (ext->extent_data.compression == BTRFS_COMPRESSION_NONE ? ed2->num_bytes : ed2->size) / fcb->Vcb->superblock.sector_size;
+            
+            ext->csum = ExAllocatePoolWithTag(NonPagedPool, len * sizeof(UINT32), ALLOC_TAG);
+            if (!ext->csum) {
+                ERR("out of memory\n");
+                goto end;
+            }
+            
+            Status = load_csum(fcb->Vcb, ext->csum, ed2->address + (ext->extent_data.compression == BTRFS_COMPRESSION_NONE ? ed2->offset : 0), len, Irp);
+            
+            if (!NT_SUCCESS(Status)) {
+                ERR("load_csum returned %08x\n", Status);
+                goto end;
+            }
+        }
+        
+        le = le->Flink;
+    }
+    
+end:
+    fcb->csum_loaded = TRUE;
+}
+
 static NTSTATUS STDCALL open_file(PDEVICE_OBJECT DeviceObject, PIRP Irp, LIST_ENTRY* rollback) {
     PFILE_OBJECT FileObject;
     ULONG RequestedDisposition;
@@ -2852,7 +2661,7 @@
     if (options & FILE_DIRECTORY_FILE && RequestedDisposition == FILE_SUPERSEDE) {
         WARN("error - supersede requested with FILE_DIRECTORY_FILE\n");
         Status = STATUS_INVALID_PARAMETER;
-        goto exit2;
+        goto exit;
     }
 
     FileObject = Stack->FileObject;
@@ -2904,13 +2713,13 @@
     
     if (Vcb->readonly && (RequestedDisposition == FILE_SUPERSEDE || RequestedDisposition == FILE_CREATE || RequestedDisposition == FILE_OVERWRITE)) {
         Status = STATUS_MEDIA_WRITE_PROTECTED;
-        goto exit2;
+        goto exit;
     }
     
     if (Vcb->readonly && Stack->Parameters.Create.SecurityContext->DesiredAccess &
         (FILE_WRITE_DATA | FILE_APPEND_DATA | FILE_WRITE_EA | FILE_WRITE_ATTRIBUTES | DELETE | WRITE_OWNER | WRITE_DAC)) {
         Status = STATUS_MEDIA_WRITE_PROTECTED;
-        goto exit2;
+        goto exit;
     }
     
     ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
@@ -2934,11 +2743,13 @@
         } else {
             WARN("FILE_OPEN_BY_FILE_ID only supported for inodes\n");
             Status = STATUS_NOT_IMPLEMENTED;
+            ExReleaseResourceLite(&Vcb->fcb_lock);
             goto exit;
         }
     } else {
         if (related && fn.Length != 0 && fn.Buffer[0] == '\\') {
             Status = STATUS_OBJECT_NAME_INVALID;
+            ExReleaseResourceLite(&Vcb->fcb_lock);
             goto exit;
         }
         
@@ -2954,7 +2765,7 @@
                 fileref = related;
             else if (NT_SUCCESS(Status)) {
                 fnoff *= sizeof(WCHAR);
-                fnoff += related->filepart.Length + sizeof(WCHAR);
+                fnoff += (related->dc ? related->dc->name.Length : 0) + sizeof(WCHAR);
                 
                 if (related->fcb->atts & FILE_ATTRIBUTE_REPARSE_POINT) {
                     Status = STATUS_REPARSE;
@@ -2965,7 +2776,7 @@
                     fn.Length -= fnoff;
 
                     Status = open_fileref(Vcb, &fileref, &fn, related, Stack->Flags & SL_OPEN_TARGET_DIRECTORY, &parsed, &fn_offset,
-                                        pool_type, Stack->Flags & SL_CASE_SENSITIVE, Irp);
+                                          pool_type, Stack->Flags & SL_CASE_SENSITIVE, Irp);
                     
                     loaded_related = TRUE;
                 }
@@ -2987,7 +2798,9 @@
         if (!NT_SUCCESS(Status)) {
             ERR("get_reparse_block returned %08x\n", Status);
             
-            free_fileref(fileref);
+            free_fileref(Vcb, fileref);
+            ExReleaseResourceLite(&Vcb->fcb_lock);
+            
             goto exit;
         }
         
@@ -2998,12 +2811,15 @@
         
         Irp->Tail.Overlay.AuxiliaryBuffer = (void*)data;
         
-        free_fileref(fileref);
+        free_fileref(Vcb, fileref);
+        ExReleaseResourceLite(&Vcb->fcb_lock);
+        
         goto exit;
     }
     
     if (NT_SUCCESS(Status) && fileref->deleted) {
-        free_fileref(fileref);
+        free_fileref(Vcb, fileref);
+        ExReleaseResourceLite(&Vcb->fcb_lock);
         
         Status = STATUS_OBJECT_NAME_NOT_FOUND;
     }
@@ -3012,19 +2828,25 @@
         if (RequestedDisposition == FILE_CREATE) {
             TRACE("file %S already exists, returning STATUS_OBJECT_NAME_COLLISION\n", file_desc_fileref(fileref));
             Status = STATUS_OBJECT_NAME_COLLISION;
-            free_fileref(fileref);
+            
+            free_fileref(Vcb, fileref);
+            ExReleaseResourceLite(&Vcb->fcb_lock);
+            
             goto exit;
         }
     } else if (Status == STATUS_OBJECT_NAME_NOT_FOUND) {
         if (RequestedDisposition == FILE_OPEN || RequestedDisposition == FILE_OVERWRITE) {
             TRACE("file doesn't exist, returning STATUS_OBJECT_NAME_NOT_FOUND\n");
+            ExReleaseResourceLite(&Vcb->fcb_lock);
             goto exit;
         }
     } else if (Status == STATUS_OBJECT_PATH_NOT_FOUND) {
         TRACE("open_fileref returned %08x\n", Status);
+        ExReleaseResourceLite(&Vcb->fcb_lock);
         goto exit;
     } else {
         ERR("open_fileref returned %08x\n", Status);
+        ExReleaseResourceLite(&Vcb->fcb_lock);
         goto exit;
     }
     
@@ -3031,6 +2853,8 @@
     if (NT_SUCCESS(Status)) { // file already exists
         file_ref* sf;
         
+        ExReleaseResourceLite(&Vcb->fcb_lock);
+        
         if (RequestedDisposition == FILE_SUPERSEDE || RequestedDisposition == FILE_OVERWRITE || RequestedDisposition == FILE_OVERWRITE_IF) {
             LARGE_INTEGER zero;
             
@@ -3039,13 +2863,21 @@
 #endif
             if (fileref->fcb->type == BTRFS_TYPE_DIRECTORY || fileref->fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY) {
                 Status = STATUS_ACCESS_DENIED;
-                free_fileref(fileref);
+                
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+                
                 goto exit;
             }
             
             if (Vcb->readonly) {
                 Status = STATUS_MEDIA_WRITE_PROTECTED;
-                free_fileref(fileref);
+                
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+                
                 goto exit;
             }
             
@@ -3052,7 +2884,11 @@
             zero.QuadPart = 0;
             if (!MmCanFileBeTruncated(&fileref->fcb->nonpaged->segment_object, &zero)) {
                 Status = STATUS_USER_MAPPED_FILE;
-                free_fileref(fileref);
+                
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+                
                 goto exit;
             }
         }
@@ -3065,7 +2901,12 @@
                            IoGetFileObjectGenericMapping(), Stack->Flags & SL_FORCE_ACCESS_CHECK ? UserMode : Irp->RequestorMode,
                            &granted_access, &Status)) {
             SeUnlockSubjectContext(&Stack->Parameters.Create.SecurityContext->AccessState->SubjectSecurityContext);
-            WARN("SeAccessCheck failed, returning %08x\n", Status);
+            TRACE("SeAccessCheck failed, returning %08x\n", Status);
+        
+            ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+            free_fileref(Vcb, fileref);
+            ExReleaseResourceLite(&Vcb->fcb_lock);
+        
             goto exit;
         }
         
@@ -3076,7 +2917,11 @@
             (FILE_WRITE_DATA | FILE_APPEND_DATA | FILE_WRITE_EA | FILE_WRITE_ATTRIBUTES | DELETE | WRITE_OWNER | WRITE_DAC) &&
             fileref->fcb->inode != SUBVOL_ROOT_INODE) {
             Status = STATUS_ACCESS_DENIED;
-            free_fileref(fileref);
+        
+            ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+            free_fileref(Vcb, fileref);
+            ExReleaseResourceLite(&Vcb->fcb_lock);
+        
             goto exit;
         }
         
@@ -3088,7 +2933,10 @@
                 WARN("could not open as deletion pending\n");
                 Status = STATUS_DELETE_PENDING;
                 
-                free_fileref(fileref);
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+                
                 goto exit;
             }
             sf = sf->parent;
@@ -3106,7 +2954,11 @@
             
             if (granted_access & ~allowed) {
                 Status = STATUS_ACCESS_DENIED;
-                free_fileref(fileref);
+                
+                ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+                free_fileref(Vcb, fileref);
+                ExReleaseResourceLite(&Vcb->fcb_lock);
+                
                 goto exit;
             }
         }
@@ -3114,7 +2966,11 @@
         if (options & FILE_DELETE_ON_CLOSE && (fileref == Vcb->root_fileref || Vcb->readonly ||
             fileref->fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY || fileref->fcb->atts & FILE_ATTRIBUTE_READONLY)) {
             Status = STATUS_CANNOT_DELETE;
-            free_fileref(fileref);
+        
+            ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+            free_fileref(Vcb, fileref);
+            ExReleaseResourceLite(&Vcb->fcb_lock);
+        
             goto exit;
         }
         
